//
// TimeIt v1.32 By Mikael Klasson 2001
// fluff@geocities.com
// http://mklasson.cjb.net
//
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <time.h>
#include <direct.h>
#include <stdlib.h>
#include "resource.h"
#include <commdlg.h>
#include <commctrl.h>
#include <shellapi.h>


#define CFGLEFT_ERR		-42
#define CFGTOP_ERR		-42
#define ID_TIMER_UPDATE		1
#define	ID_TIMER_ABOUT		3
#define	ID_TIMER_SCROLL		4
#define	ID_TIMER_FIRST		39000
#define	ID_TIMER_LAST		39998
#define	ID_TIMERDLG		39999
#define	ID_H			39000
#define	ID_M			39001
#define	ID_S			39002
#define	ID_HTEXT		39003
#define	ID_MTEXT		39004
#define	ID_STEXT		39005
#define	ID_ENTER		39006
#define	ID_NAME			39007
#define	ID_MSG			39008
#define	ID_CMD			39009
#define	ID_SAVE			39010
#define	ID_NAMETEXT		39011
#define	ID_MSGTEXT		39012
#define	ID_SAVETEXT		39013

#define	TIME_TIMER_ABOUT	1000 / 30

#define	DEGINC			2

struct Timer_t {
	char	*pszName;		// name to display in TimeIt
	char	*pszMsg;		// msg to display when timer expires
	char	*pszCmd;		// command to execute when timer expires
	int	iSecs;			// time in seconds
	bool	fActive;		// true if this timer is active and counting
	time_t	tStarted;		// time when timer was started (in seconds since 1970-01-01)
	int	fSave;			// true if this timer should be saved to the inifile
};


const char *pszMonths[12] = { "Jan","Feb","Mar","Apr","May","Jun",
			      "Jul","Aug","Sep","Oct","Nov","Dec" };

const char *pszDays[7] = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };


LRESULT CALLBACK	WindowProc( HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam );
LRESULT CALLBACK	AboutDlgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
void			ReleaseTimer( void );
void			UpdateTime( void );
void			ReadIniFile( void );
int			ReadIniVal( char *pszIniFile, char *pszKey, int iDefault );
char *			ReadIniStr( char *pszIniFile, char *pszKey, char *pszDefault );
bool			WriteIniFile( void );
bool			Init( void );
void			DrawPic( HWND hWnd, int iPicWidth, int iPicHeight, char *pOrigBitmap, BITMAPINFO *pbmi, char *pBitmap, int iDeg );
void			GetTime( char *pszTime );
BOOL CALLBACK		EnumWindowsProc(  HWND hWnd, LPARAM lParam );
int			SetFont( LOGFONT *plf );
int			show_timer_dlg( void );
LRESULT			CALLBACK wndproc_timer_dlg( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );


char		gaversion[] = "1.32";
HINSTANCE	ghinstance;				// application's instance handle
HWND		ghwnd = NULL;				// handle of main dialog
HWND		ghwndtxt = NULL;			// handle of static control
HWND		ghtooltip = NULL;
HWND		ghwndtimer = NULL;			// handle of timer dialog
bool		fTimerIDUpdateActive = false;
bool		fTimerIDScrollActive = false;
char		gainifile[261];				// inifile's path and name
HMENU		ghmenu;					// global right-click menu
HMENU		ghsubmenu;				// "Timers" submenu
bool		gfaboutactive = false;			// true if about dlgbox is shown
char		gatooltiptext[256];			// buffer for tooltip text

// config
int			giCfgTop;
int			giCfgLeft;
char *			gpCfgFontName = "Microsoft Sans Serif";
int			giCfgFontSize = 11;
int			giCfgFontWeight = 400;
int			giCfgFontItalic = 0;
int			giCfgWindowSnap = 20;
int			giCfgScrollDelay = 0;
int			giCfgToolTip = 1;
int			giCfgWindowFrame = 0;
int			giCfgUseColors = 1;
unsigned int		guCfgBkgColor = 0x3dbae8;	// bbggrr format
unsigned int		guCfgTxtColor = 0x202020;	// bbggrr format
struct Timer_t	**	gTimers;
int			giTimersCnt;


//
// WinMain
//
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	MSG		msg;

	ghinstance = hInstance;

	if( !Init() ) {
		MessageBox( NULL, "Initialization error, exiting...", "TimeIt", MB_OK | MB_ICONEXCLAMATION );
		return 1;
	}

	while( TRUE ) {
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			if( !GetMessage( &msg, NULL, 0, 0 ) ) {
				break;
			}
			if( !IsDialogMessage( ghwndtimer, &msg ) ) {
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
		} else {
			WaitMessage();
		}
	}

	WriteIniFile();

	return msg.wParam;
}

int SetFont( LOGFONT *plf )
{
	HFONT	hf;
	HDC	hdc;
	SIZE	s;

	if( !( hf = CreateFontIndirect( plf ) ) ) {
		MessageBox( NULL, "Error", "Ack, couldn't create the selected font!", MB_OK );
		return 0;
	}
	SendMessage( GetDlgItem( ghwnd, IDC_LTIME), WM_SETFONT, (WPARAM) hf, 1 );


	SendMessage( ghwnd, WM_SETFONT, (WPARAM) hf, 1 );



	memset( &s, 0, sizeof( s ) );
	hdc = GetDC( ghwndtxt );
	SelectObject( hdc, hf );
	GetTextExtentPoint32( hdc, "23:59", 5, &s );
	if( giCfgWindowFrame ) {
		s.cx += 4;
		s.cy += 2;
	} else {
		s.cx += 1;
	}
	ReleaseDC( ghwndtxt, hdc );

	free( gpCfgFontName );
	gpCfgFontName = _strdup( plf->lfFaceName );
	giCfgFontSize = abs( plf->lfHeight );
	giCfgFontWeight = abs( plf->lfWeight );
	giCfgFontItalic = abs( plf->lfItalic );

	SetWindowPos( ghwnd,
		NULL, 0, 0, s.cx, s.cy, SWP_NOMOVE | SWP_NOZORDER );
	SetWindowPos( ghwndtxt,
		NULL, 0, 0, s.cx, s.cy, SWP_NOMOVE | SWP_NOZORDER );
	return 0;
}

unsigned int char_hex_to_uint( char c )
{
	if( c >= '0' && c <= '9' ) {
		return c - '0';
	} else if( c >= 'A' && c <= 'F' ) {
		return c - 'A' + 10;
	} else if( c >= 'a' && c <= 'f' ) {
		return c - 'a' + 10;
	}

	return 0;
}

unsigned int text_rgb_to_uint_bgr( char *prgb )
{
	return ( ( ( char_hex_to_uint( prgb[0] ) << 4 ) + char_hex_to_uint( prgb[1] ) ) ) + 
	       ( ( ( char_hex_to_uint( prgb[2] ) << 4 ) + char_hex_to_uint( prgb[3] ) ) << 8 ) + 
	       ( ( ( char_hex_to_uint( prgb[4] ) << 4 ) + char_hex_to_uint( prgb[5] ) ) << 16 );
}

char uint_to_char_hex( unsigned int u )
{
	if( u < 10 ) {
		return '0' + u;
	} else if( u < 16 ) {
		return 'A' + u - 10;
	}

	return '0';
}

void uint_bgr_to_text_rgb( unsigned int ubgr, char *prgb )
{
	prgb[0] = uint_to_char_hex( ( ubgr >> 4 ) & 0x0f );
	prgb[1] = uint_to_char_hex( ( ubgr >> 0 ) & 0x0f );
	prgb[2] = uint_to_char_hex( ( ubgr >> 12 ) & 0x0f );
	prgb[3] = uint_to_char_hex( ( ubgr >> 8 ) & 0x0f );
	prgb[4] = uint_to_char_hex( ( ubgr >> 20 ) & 0x0f );
	prgb[5] = uint_to_char_hex( ( ubgr >> 16 ) & 0x0f );
	prgb[6] = 0;
}

UINT CALLBACK CFHookProc( HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam )
{
	LOGFONT	lf;

	switch( umsg ) {
	case WM_COMMAND:
		if( wparam == 1026 ) {	// How the _hell_ am I supposed to know this?
			SendMessage( hwnd, WM_CHOOSEFONT_GETLOGFONT, NULL, (LPARAM) &lf );
			SetFont( &lf );
			return 0;
		}
	}

	return 0;
}

// Handles all WM_NOTIFY msgs
int handle_wm_notify( HWND hwnd, WPARAM wparam, LPARAM lparam )
{
	LPNMTTDISPINFO	p;
	struct tm	*ptm;
	time_t		t;

	if( ((LPNMHDR) lparam)->code == TTN_NEEDTEXT ) {
		p = (LPNMTTDISPINFO) lparam;
		time( &t );
		ptm = localtime( &t );

		ptm->tm_year += 1900;
		sprintf( gatooltiptext, "%s %s %.2d, %d", pszDays[ptm->tm_wday], pszMonths[ptm->tm_mon], ptm->tm_mday, ptm->tm_year );

		p->hinst = NULL;
		p->lpszText = gatooltiptext;
	}

	return 0;
}

//
// Handle msgs for IDD_MAIN
//
LRESULT CALLBACK WindowProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	RECT		rWnd;
	int		iWidth;
	int		iHeight;
	static int	iXOff;
	static int	iYOff;

	switch( msg ) {
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;

	case WM_CLOSE:
		ReleaseTimer();
		ReleaseCapture();
		break;

	case WM_ENDSESSION:
		if( wParam ) {
			ReleaseTimer();
			ReleaseCapture();
			WriteIniFile();
		}
		return 0;

	case WM_TIMER:
		if( wParam == ID_TIMER_UPDATE ) {
			UpdateTime();
			SetWindowPos( ghwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE );
			return false;
		} else if( wParam == ID_TIMER_SCROLL ) {
			char szText[128];

			GetDlgItemText( ghwnd, IDC_LTIME, szText, 128 );
			if( strlen( szText ) > 5 ) {	// > strlen( "03:03")
				SetDlgItemText( ghwnd, IDC_LTIME, szText + 1 );
			} else {
				KillTimer( ghwnd, wParam );
				fTimerIDScrollActive = false;
				fTimerIDUpdateActive = true;
				UpdateTime();
			}
			return false;
		}
		
		KillTimer( ghwnd, wParam );
		gTimers[wParam - ID_TIMER_FIRST]->fActive = false;
		if( gTimers[wParam - ID_TIMER_FIRST]->pszCmd[0] ) {
			ShellExecute( NULL, "open", gTimers[wParam - ID_TIMER_FIRST]->pszCmd, "", ".", SW_SHOW );
		}
		if( gTimers[wParam - ID_TIMER_FIRST]->pszMsg[0] ) {
			MessageBox( NULL, gTimers[wParam - ID_TIMER_FIRST]->pszMsg, "TimeIt timer expired", MB_OK | MB_SYSTEMMODAL | MB_ICONINFORMATION );
		}
		return false;

	case WM_INITMENUPOPUP:
		MENUITEMINFO	miiM;
		char		*pszT;
		time_t		tTime;
		int		i;

		if( (HMENU) wParam != ghsubmenu ) {
			return false;
		}

		for( i = 0; i < giTimersCnt; i++ ) {
			memset( &miiM, 0, sizeof( MENUITEMINFO ) );
			miiM.cbSize = sizeof( MENUITEMINFO );
			miiM.fMask = MIIM_TYPE;
			if( !GetMenuItemInfo( ghsubmenu, ID_TIMER_FIRST + i, false, &miiM ) ) {
				return false;
			}
			miiM.cbSize = sizeof( MENUITEMINFO );
			miiM.fMask = MIIM_STATE | MIIM_TYPE;
			miiM.fType = MFT_STRING;
			pszT = (char *) malloc( 80 );
			free( miiM.dwTypeData );
			if( gTimers[i]->fActive ) {
				miiM.fState = MFS_ENABLED | MFS_CHECKED;
				time( &tTime );
				tTime = gTimers[i]->iSecs - ( tTime - gTimers[i]->tStarted );
			} else {
				miiM.fState = MFS_ENABLED | MFS_UNCHECKED;
				tTime = gTimers[i]->iSecs;
			}
			_snprintf( pszT, 80, "%s\t[%.2dh %.2dm %.2ds] %s", gTimers[i]->pszName,
				( tTime / ( 60 * 60 ) ) % 60,
				( tTime / 60 ) % 60,
				tTime % 60,
				gTimers[i]->pszCmd[0] ? gTimers[i]->pszCmd : ""
				);
			miiM.dwTypeData = pszT;
			miiM.cch = 0;
			SetMenuItemInfo( GetSubMenu( ghmenu, 0 ), ID_TIMER_FIRST + i, false, &miiM );
		}
		return false;

	case WM_RBUTTONDOWN:
		if( !gfaboutactive ) {
			TrackPopupMenu( ghmenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON, 
				LOWORD( GetMessagePos() ), HIWORD( GetMessagePos() ), 
				0, hWnd, NULL );
		}
		return false;

	case WM_LBUTTONDOWN:
		SetCapture( hWnd );
		iXOff = LOWORD( lParam );
		iYOff = HIWORD( lParam );
		return false;

	case WM_MOUSEMOVE:
		if( wParam & MK_LBUTTON ) {
			GetWindowRect( hWnd, &rWnd );
			iWidth = rWnd.right - rWnd.left;
			iHeight = rWnd.bottom - rWnd.top;
			giCfgLeft = LOWORD( GetMessagePos() ) - iXOff;
			giCfgTop = HIWORD( GetMessagePos() ) - iYOff;
			if( ( LOWORD( lParam ) >= 0 ) && ( HIWORD( lParam ) >= 0 ) &&
			    ( LOWORD( lParam ) <= iWidth ) && ( HIWORD( lParam ) <= iHeight ) ) {
				giCfgLeft = rWnd.left + LOWORD( lParam ) - iXOff;
				giCfgTop = rWnd.top + HIWORD( lParam ) - iYOff;
			}
			EnumWindows( EnumWindowsProc, ( iHeight << 16 ) + iWidth );

			MoveWindow( hWnd, giCfgLeft, giCfgTop, iWidth, iHeight, true );
		} else {
			char		szT[256];
			char		szNew[256];
			struct tm	*tmTime;
			time_t		aclock;

			if( fTimerIDScrollActive || !giCfgScrollDelay ) {
				return false;
			}
			fTimerIDScrollActive = true;

			time( &aclock );
			tmTime = localtime( &aclock );

			tmTime->tm_year += 1900;
			GetDlgItemText( ghwnd, IDC_LTIME, szT, 256 );
			sprintf( szNew, "%s - %s %s %.2d, %d - %s", szT, pszDays[tmTime->tm_wday], pszMonths[tmTime->tm_mon], tmTime->tm_mday, tmTime->tm_year, szT );
			SetDlgItemText( ghwnd, IDC_LTIME, szNew );

			if( !SetTimer( hWnd, ID_TIMER_SCROLL, giCfgScrollDelay, NULL ) ) {
				MessageBox( NULL, "Couldn't setup timer!", "Error!", MB_OK );
				EndDialog( hWnd, false );
				return false;
			}
		}
		return 0;

	case WM_LBUTTONUP:
		ReleaseCapture();
		return 0;

	case WM_NOTIFY:
		handle_wm_notify( hWnd, wParam, lParam );
		return 0;

	case WM_CTLCOLORSTATIC:
		if( giCfgUseColors && (HWND) lParam == ghwndtxt ) {
			SetBkColor( (HDC) wParam, guCfgBkgColor );
			SetTextColor( (HDC) wParam, guCfgTxtColor );
			return (long) GetStockObject( LTGRAY_BRUSH );
		}
		return 0;

	case WM_COMMAND:
		switch( wParam ) {
		case ID_MAIN_ABOUT:
			DialogBox( ghinstance, MAKEINTRESOURCE( IDD_ABOUT ), NULL, (DLGPROC) AboutDlgProc );
			return false;

		case ID_MAIN_FONT:
			CHOOSEFONT	cf;
			LOGFONT		lf;
			memset( &lf, 0, sizeof( lf ) );
			memset( &cf, 0, sizeof( cf ) );
			cf.lStructSize = sizeof( cf );
			cf.Flags = CF_BOTH | CF_APPLY | CF_ENABLEHOOK;
			cf.lpfnHook = CFHookProc;
			cf.lpLogFont = &lf;
			if( ChooseFont( &cf ) ) {
				SetFont( &lf );
			}
			return 0;

		case ID_MAIN_QUIT:
		case IDCANCEL:
			ReleaseTimer();
			ReleaseCapture();
			PostQuitMessage( 0 );
			return false;

		case ID_TIMERDLG:
			show_timer_dlg();
			return false;
		}

		if( wParam >= ID_TIMER_FIRST && wParam <= ID_TIMER_LAST ) {
			if( gTimers[wParam - ID_TIMER_FIRST]->fActive ) {
				KillTimer( hWnd, wParam );
				gTimers[wParam - ID_TIMER_FIRST]->fActive = false;
				return false;
			} else {
				if( !SetTimer( hWnd, wParam, gTimers[wParam - ID_TIMER_FIRST]->iSecs * 1000, NULL ) ) {
					MessageBox( NULL, "Couldn't setup timer!", "Error!", MB_OK );
					EndDialog( hWnd, false );
					return false;
				}
				gTimers[wParam - ID_TIMER_FIRST]->fActive = true;
				time_t	tTime;
				time( &tTime );
				gTimers[wParam - ID_TIMER_FIRST]->tStarted = tTime;
				return false;
			}
		}
		return false;
	}

	return DefWindowProc( hWnd, msg, wParam, lParam );
}


//
// decode RLE data
// returns:	ptr to unpacked data
//		NULL if error
//
char *unpack( unsigned char *pin )
{
	int	ncnt;
	int	nchr;
	int	n;
	int	nmaxburstlen;
	char *	pout;
	char *	ppic;

	if( !( pout = (char *) malloc( *( (unsigned int *)pin ) ) ) ) {
		return NULL;
	}
	ppic = pout;
	nmaxburstlen = *( pin + 4 );
	pin += 4 + 1;

	while( ( ncnt = (int) *pin++ ) ) {
		if( ncnt < 256 - nmaxburstlen ) {
			nchr = *pin++;
			for( n = 0; n < ncnt; n++ ) {
				*pout++ = nchr;
			}
		} else {
			ncnt -= 255 - nmaxburstlen;
			memcpy( pout, pin, ncnt );
			pin += ncnt;
			pout += ncnt;
		}
	}

	return ppic;
}


//
// Handle msgs for IDD_ABOUT
//
LRESULT CALLBACK AboutDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static bool		fDrawn = false;
	static char		*pOrigPic;
	static char		*pOrigPal;
	static char		*pOrigBitmap;
	static char		*pBitmap;
	static int		iPicWidth;
	static int		iPicHeight;
	static HANDLE		hRes;
	RECT			rWnd;
	int			i;
	static char		bmi[sizeof( BITMAPINFOHEADER ) + 256*4];
	static BITMAPINFOHEADER	*pbmih;
	static int		iDeg = 0;

	switch( msg ) {
	case WM_INITDIALOG:
		gfaboutactive = true;
		hRes = FindResource( NULL, MAKEINTRESOURCE( IDR_RLE_DATA1 ), "RLE_DATA" );
		hRes = LoadResource( NULL, (struct HRSRC__ *) hRes );
		pOrigPic = unpack( (unsigned char *) LockResource( hRes ) );
		pOrigPal = pOrigPic + 10;
		pOrigBitmap = pOrigPal + 256 * 3;
		iPicWidth = *( (short int *) pOrigPic + 2 );
		iPicHeight = *( (short int *) pOrigPic + 3 );

		pbmih = (BITMAPINFOHEADER *) &bmi;
		pbmih->biSize = sizeof( BITMAPINFOHEADER );
		pbmih->biWidth = iPicWidth;
		pbmih->biHeight = -iPicHeight;		// negative -> draw from topleft
		pbmih->biPlanes = 1;
		pbmih->biBitCount = 8;
		pbmih->biCompression = BI_RGB;
		pbmih->biSizeImage = 0;
		pbmih->biXPelsPerMeter = 0;
		pbmih->biYPelsPerMeter = 0;
		pbmih->biClrUsed = 0;
		pbmih->biClrImportant = 0;

		for( i = 0; i < 256; i++ ) {
			*( bmi + sizeof( BITMAPINFOHEADER ) + i * 4 + 0 ) = pOrigPal[i * 3 + 2] * 4;
			*( bmi + sizeof( BITMAPINFOHEADER ) + i * 4 + 1 ) = pOrigPal[i * 3 + 1] * 4;
			*( bmi + sizeof( BITMAPINFOHEADER ) + i * 4 + 2 ) = pOrigPal[i * 3 + 0] * 4;
			*( bmi + sizeof( BITMAPINFOHEADER ) + i * 4 + 3 ) = 0;
		}

		pBitmap = (char *) malloc( iPicWidth * iPicHeight );

		GetWindowRect( hWnd, &rWnd );
		MoveWindow( hWnd, rWnd.left + ( rWnd.right - rWnd.left - iPicWidth ) / 2, 
			rWnd.top + ( rWnd.bottom - rWnd.top - iPicHeight ) / 2, 
			iPicWidth, iPicHeight, false );

		/* Scroll version-number in main window */
		char		szT[256];
		char		szNew[256];

		GetDlgItemText( ghwnd, IDC_LTIME, szT, 256 );
		sprintf( szNew, "%s - TimeIt v%s", szT, gaversion );
		GetTime( szT );
		sprintf( szNew, "%s - %s", szNew, szT );
		SetDlgItemText( ghwnd, IDC_LTIME, szNew );

		if( !fTimerIDScrollActive ) {
			// call the timer once every x msecs
			if( !SetTimer( ghwnd, ID_TIMER_SCROLL, 300, NULL ) ) {
				MessageBox( NULL, "Couldn't setup timer!", "Error!", MB_OK );
				EndDialog( hWnd, false );
				return true;
			}
		}

		fTimerIDScrollActive = true;

		return true;

	case WM_LBUTTONDOWN:
		KillTimer( hWnd, ID_TIMER_ABOUT );
		free( pBitmap );
		free( pOrigPic );
		gfaboutactive = false;
		EndDialog( hWnd, true );
		return false;

	case WM_TIMER:
		if( wParam == ID_TIMER_ABOUT ) {
			DrawPic( hWnd, iPicWidth, iPicHeight, pOrigBitmap, (BITMAPINFO *) &bmi, pBitmap, iDeg += DEGINC );
		}
		return false;

	case WM_COMMAND:
		switch( wParam ) {
		case IDCANCEL:
			KillTimer( hWnd, ID_TIMER_ABOUT );
			free( pBitmap );
			gfaboutactive = false;
			EndDialog( hWnd, true );
			return false;
		}
		return false;

	case WM_PAINT:
		DrawPic( hWnd, iPicWidth, iPicHeight, pOrigBitmap, (BITMAPINFO *) &bmi, pBitmap, iDeg );
		return false;
	}

	return false;
}


//
// ReleaseTimer
//
void ReleaseTimer( void )
{
	int	i;

	fTimerIDUpdateActive = false;
	KillTimer( ghwnd, ID_TIMER_UPDATE );
	fTimerIDScrollActive = false;
	KillTimer( ghwnd, ID_TIMER_SCROLL );
	for( i = 0; i < giTimersCnt; i++ ) {
		KillTimer( ghwnd, ID_TIMER_FIRST + i );
	}
}


//
// UpdateTime
//
void UpdateTime( void )
{
	char	szT[256];

	if( !fTimerIDUpdateActive ) {
		return;
	}

	fTimerIDUpdateActive = false;

	GetTime( szT );
	strcat( szT, "     " );

	SetDlgItemText( ghwnd, IDC_LTIME, szT );

	fTimerIDUpdateActive = true;

	return;
}


//
// GetTime
//
void GetTime( char *pszTime )
{
	struct tm	*tmTime;
	time_t		aclock;

	time( &aclock );
	tmTime = localtime( &aclock );

	sprintf( pszTime, "%.2d:%.2d", tmTime->tm_hour, tmTime->tm_min );

	return;
}


//
// ReadIniFile
//
void ReadIniFile( void )
{
	char	a[7];
	char *	p;

	giCfgTop = ReadIniVal( gainifile, "top", CFGTOP_ERR );
	giCfgLeft = ReadIniVal( gainifile, "left", CFGLEFT_ERR );
	gpCfgFontName = ReadIniStr( gainifile, "font_name", gpCfgFontName );
	giCfgFontSize = ReadIniVal( gainifile, "font_size", giCfgFontSize );
	giCfgFontWeight = ReadIniVal( gainifile, "font_weight", giCfgFontWeight );
	giCfgFontItalic = ReadIniVal( gainifile, "font_italic", giCfgFontItalic );
	giCfgWindowSnap = ReadIniVal( gainifile, "window_snap", giCfgWindowSnap );
	giCfgScrollDelay = ReadIniVal( gainifile, "scroll_delay", giCfgScrollDelay );
	giCfgToolTip = ReadIniVal( gainifile, "tooltip", giCfgToolTip );
	giCfgWindowFrame = ReadIniVal( gainifile, "windowframe", giCfgWindowFrame );
	giCfgUseColors = ReadIniVal( gainifile, "use_colors", giCfgUseColors );

	uint_bgr_to_text_rgb( guCfgBkgColor, a );
	p = ReadIniStr( gainifile, "background_color", a );
	guCfgBkgColor = text_rgb_to_uint_bgr( p );

	uint_bgr_to_text_rgb( guCfgTxtColor, a );
	p = ReadIniStr( gainifile, "text_color", a );
	guCfgTxtColor = text_rgb_to_uint_bgr( p );

	return;
}


//
// ReadIniVal
//
int ReadIniVal( char *pszIniFile, char *pszKey, int iDefault )
{
	FILE	*in;
	char	szLine[81];
	int	iKeyLen;
	char	*psVal;
	int	iVal = iDefault;

	if( !( in = fopen( pszIniFile, "rt" ) ) ) {
		return iVal;
	}

	do {
		fgets( szLine, 80, in );
		if( ( psVal = strchr( szLine, '=' ) ) ) {
			iKeyLen = psVal - szLine;
			if( !_strnicmp( szLine, pszKey, iKeyLen ) ) {
				iVal = atoi( psVal + 1 );
				break;
			}
		}
	} while( !feof( in ) );

	fclose( in );

	return iVal;
}


//
// ReadIniStr
//
char *ReadIniStr( char *pszIniFile, char *pszKey, char *pszDefault )
{
	FILE	*in;
	char	szLine[81];
	int	iKeyLen;
	char	*psVal;
	char	*pszStr = pszDefault;

	if( !( in = fopen( pszIniFile, "rt" ) ) ) {
		return pszDefault;
	}

	do {
		fgets( szLine, 80, in );
		if( ( psVal = strchr( szLine, '=' ) ) ) {
			iKeyLen = psVal - szLine;
			if( !_strnicmp( szLine, pszKey, iKeyLen ) ) {
				pszStr = _strdup( psVal + 1 );
				if( *(pszStr + strlen( pszStr ) - 1 ) == '\n' ) {
					*(pszStr + strlen( pszStr ) - 1 ) = '\0';
				}
				break;
			}
		}
	} while( !feof( in ) );

	fclose( in );

	return pszStr;
}


//
// WriteIniFile
//
bool WriteIniFile( void )
{
	FILE	*out;
	int	n,i;
	char	a[7];

	if( !( out = fopen( gainifile, "wt" ) ) ) {
		return false;
	}

	fprintf( out, "[TimeIt]\n" );
	fprintf( out, "version=%s\n", gaversion );
	fprintf( out, "top=%d\n", giCfgTop );
	fprintf( out, "left=%d\n\n", giCfgLeft );

	fprintf( out, "font_name=%s\n", gpCfgFontName );
	fprintf( out, "font_size=%d\n", giCfgFontSize );
	fprintf( out, "font_weight=%d\n", giCfgFontWeight );
	fprintf( out, "font_italic=%d\n\n", giCfgFontItalic );

	fprintf( out, "; snap sensitivity; 0 to disable window snapping\n" );
	fprintf( out, "window_snap=%d\n\n", giCfgWindowSnap );

	fprintf( out, "; scroll delay; 0 to disable date scrolling\n" );
	fprintf( out, "scroll_delay=%d\n\n", giCfgScrollDelay );

	fprintf( out, "; display date info in a tooltip? 0 to disable\n" );
	fprintf( out, "tooltip=%d\n\n", giCfgToolTip );

	fprintf( out, "; draw a frame around the window? 0 or 1\n" );
	fprintf( out, "windowframe=%d\n\n", giCfgWindowFrame );

	fprintf( out, "; use the custom colors specified below? 0 or 1\n" );
	fprintf( out, "use_colors=%d\n\n", giCfgUseColors );

	uint_bgr_to_text_rgb( guCfgBkgColor, a );
	fprintf( out, "; background color in hex RRGGBB format, e.g. ffff00 for yellow\n" );
	fprintf( out, "background_color=%s\n\n", a );

	uint_bgr_to_text_rgb( guCfgTxtColor, a );
	fprintf( out, "; text color in hex RRGGBB format, e.g. ff00ff for purple\n" );
	fprintf( out, "text_color=%s\n\n", a );

	for( n = 0, i = 1; n < giTimersCnt; n++ ) {
		if( gTimers[n]->fSave ) {
			fprintf( out, "timer%dname=%s\n", i, gTimers[n]->pszName );
			fprintf( out, "timer%dmsg=%s\n", i, gTimers[n]->pszMsg );
			fprintf( out, "timer%dcmd=%s\n", i, gTimers[n]->pszCmd );
			fprintf( out, "timer%dmins=%d\n", i, gTimers[n]->iSecs / 60 );
			fprintf( out, "timer%dsecs=%d\n\n", i, gTimers[n]->iSecs % 60 );
			i++;
		}
	}

	fclose( out );

	return true;
}


//
// Init
//
bool Init( void )
{
	int		i;
	char		szT[256];
	MENUITEMINFO	miiM;
	WNDCLASS	wc;
	RECT		rWnd;
	int		iWidth;
	int		iHeight;
	static int	iXOff;
	static int	iYOff;
	LOGFONT		lf;
	TOOLINFO	ti;

	_getcwd( gainifile, 260 );
	strcat( gainifile, "\\timeit.ini" );

	ReadIniFile();

	// insert a "Timers" popup menu in the main menu
	ghmenu = GetSubMenu( LoadMenu( ghinstance, MAKEINTRESOURCE( IDR_MMAIN ) ), 0 );

	memset( &miiM, 0, sizeof( MENUITEMINFO ) );

	miiM.cbSize = sizeof( MENUITEMINFO );
	miiM.fMask = MIIM_TYPE | MIIM_ID | MIIM_SUBMENU;
	miiM.fType = MFT_STRING;
	miiM.wID = 42;
	miiM.hSubMenu = CreatePopupMenu();
	miiM.dwTypeData = "&Timers";
	miiM.cch = 0;

	InsertMenuItem( ghmenu, 0, true, &miiM );

	if( !( ghsubmenu = GetSubMenu( ghmenu, 0 ) ) ) {
		return false;
	}


	// get number of timers
	for( giTimersCnt = 0; true; giTimersCnt++ ) {
		sprintf( szT, "timer%dname", giTimersCnt + 1 );
		if( !strlen( ReadIniStr( gainifile, szT, "" ) ) ) {
			break;
		}
	}

	// init and insert all timers
	if( !( gTimers = (struct Timer_t **) malloc( sizeof( struct Timer_t * ) * giTimersCnt ) ) ) {
		return false;
	}

	for( i = 0; i < giTimersCnt; i++ ) {
		if( !( gTimers[i] = (struct Timer_t *) malloc( sizeof( struct Timer_t ) ) ) ) {
			return false;
		}
		sprintf( szT, "timer%dname", i + 1 );
		gTimers[i]->pszName = ReadIniStr( gainifile, szT, "Inifile error" );
		sprintf( szT, "timer%dmsg", i + 1 );
		gTimers[i]->pszMsg = ReadIniStr( gainifile, szT, "" );
		sprintf( szT, "timer%dcmd", i + 1 );
		gTimers[i]->pszCmd = ReadIniStr( gainifile, szT, "" );
		sprintf( szT, "timer%dmins", i + 1 );
		gTimers[i]->iSecs = ReadIniVal( gainifile, szT, 0 ) * 60;
		sprintf( szT, "timer%dsecs", i + 1 );
		gTimers[i]->iSecs += ReadIniVal( gainifile, szT, 0 );
		gTimers[i]->fActive = false;
		gTimers[i]->fSave = true;

		memset( &miiM, 0, sizeof( MENUITEMINFO ) );
		miiM.cbSize = sizeof( MENUITEMINFO );
		miiM.fMask = MIIM_ID | MIIM_STATE | MIIM_SUBMENU | MIIM_TYPE;
		miiM.fType = MFT_STRING;
		miiM.fState = MFS_ENABLED | MFS_UNCHECKED;
		miiM.wID = ID_TIMER_FIRST + i;
		miiM.hSubMenu = NULL;
		miiM.dwTypeData = _strdup( gTimers[i]->pszName );
		miiM.cch = 0;
		InsertMenuItem( ghsubmenu, i, true, &miiM );
	}

	memset( &miiM, 0, sizeof( MENUITEMINFO ) );
	miiM.cbSize = sizeof( MENUITEMINFO );
	miiM.fMask = MIIM_ID | MIIM_STATE | MIIM_SUBMENU | MIIM_TYPE;
	miiM.fType = MFT_STRING;
	miiM.fState = MFS_ENABLED | MFS_UNCHECKED;
	miiM.wID = ID_TIMERDLG;
	miiM.hSubMenu = NULL;
	miiM.dwTypeData = "New timer";
	miiM.cch = 0;
	InsertMenuItem( ghsubmenu, i, true, &miiM );

	memset( &wc, 0, sizeof( wc ) );
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.hInstance = ghinstance;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = (HBRUSH) COLOR_WINDOW;
	wc.lpszClassName = "TimeIt";
	wc.lpszMenuName = NULL;
	if( !RegisterClass( &wc ) ) {
		MessageBox( NULL, "RegisterClass() failed!", "TimeIt", MB_OK );
		return 0;
	}

	if( !( ghwnd = CreateWindowEx( WS_EX_TOOLWINDOW | WS_EX_TOPMOST /*| WS_EX_TRANSPARENT*/, "TimeIt", "TimeIt",
			WS_POPUP | ( giCfgWindowFrame ? WS_BORDER : 0 ),
			200, 
			200,
			0, 
			0,
			NULL,
			NULL,
			ghinstance,
			NULL ) ) ) {
		MessageBox( NULL, "CreateWindow( ghwnd ) failed!", "TimeIt", MB_OK );
		return 0;
	}

	if( !( ghwndtxt = CreateWindowEx( 0 /*| WS_EX_TRANSPARENT*/, "STATIC", "", 
			WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			0, 0, 0, 0,
			ghwnd,
			(HMENU) IDC_LTIME,
			ghinstance,
			NULL ) ) ) {
		MessageBox( NULL, "CreateWindow( ghwndtxt ) failed!", "TimeIt", MB_OK );
		return 0;
	}

	fTimerIDUpdateActive = true;
	UpdateTime();
	
	if( giCfgLeft != CFGLEFT_ERR && giCfgTop != CFGTOP_ERR ) {
		GetWindowRect( ghwnd, &rWnd );
		iWidth = rWnd.right - rWnd.left;
		iHeight = rWnd.bottom - rWnd.top;
		MoveWindow( ghwnd, giCfgLeft, giCfgTop, iWidth, iHeight, true );
	}

	if( !SetTimer( ghwnd, ID_TIMER_UPDATE, 60000, NULL ) ) {
	//if( !SetTimer( ghwnd, ID_TIMER_UPDATE, 3000, NULL ) ) {
		MessageBox( NULL, "Couldn't setup timer!", "Error!", MB_OK );
		return 0;
	}

	ShowWindow( ghwnd, SW_SHOW );
	UpdateWindow( ghwnd );

	memset( &lf, 0, sizeof( lf ) );
	lf.lfHeight = -giCfgFontSize;
	lf.lfWeight = giCfgFontWeight;
	lf.lfItalic = giCfgFontItalic;
	_snprintf( lf.lfFaceName, LF_FACESIZE, "%s", gpCfgFontName );
	SetFont( &lf );

	if( giCfgToolTip ) {
		INITCOMMONCONTROLSEX	icc;
		memset( &icc, 0, sizeof( icc ) );
		icc.dwSize = sizeof( icc );
		icc.dwICC = ICC_BAR_CLASSES;
		if( !InitCommonControlsEx( &icc ) ) {
			MessageBox( NULL, "InitCommonControlsEx() failed!", "Error", MB_OK );
			return 0;
		}

		if( !( ghtooltip = CreateWindowEx( 0, TOOLTIPS_CLASS, "", 
				TTS_ALWAYSTIP,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				ghwnd,
				NULL,
				ghinstance,
				NULL ) ) ) {
			return 0;
		}

		memset( &ti, 0, sizeof( ti ) );
		ti.cbSize = sizeof( ti );
		ti.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
		ti.hwnd = ghwnd;
		ti.uId = (unsigned int) ghwnd;
		ti.hinst = ghinstance;
		ti.lpszText = LPSTR_TEXTCALLBACK;
		ti.lParam = 0;
		SendMessage( ghtooltip, TTM_ADDTOOL, 0, (LPARAM) &ti );
	}

	memset( &wc, 0, sizeof( wc ) );
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = wndproc_timer_dlg;
	wc.hInstance = ghinstance;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = (HBRUSH) GetStockObject( LTGRAY_BRUSH );
	wc.lpszClassName = "TimeIt_timer";
	wc.lpszMenuName = NULL;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = DLGWINDOWEXTRA; // because we're using it as a customized dialogbox of some sort...
	if( !RegisterClass( &wc ) ) {
		MessageBox( NULL, "RegisterClass( TimeIt_timer ) failed!", "TimeIt", MB_OK );
		return 0;
	}

	return 1;
}


void DrawPic( HWND hWnd, int iPicWidth, int iPicHeight, char *pOrigBitmap, BITMAPINFO *pbmi, char *pBitmap, int iDeg )
{
	HDC	PaintDC;
	int	x, y;

	for( y = 0; y < iPicHeight; y++ ) {
		for( x = 0; x < iPicWidth; x++ ) {
			pBitmap[y * iPicWidth + x] = pOrigBitmap[y * iPicWidth + x];
		}
	}

	PaintDC = GetDC( hWnd );

	StretchDIBits( PaintDC, 
		0, 0,
		iPicWidth, iPicHeight,
		0, 0,
		iPicWidth, iPicHeight,
		pBitmap,
		pbmi,
		DIB_RGB_COLORS,
		SRCCOPY );

	ReleaseDC( hWnd, PaintDC );

	return;
}


BOOL CALLBACK EnumWindowsProc(  HWND hWnd, LPARAM lParam )
{
	RECT	rWnd;
	int	iTop, iLeft;
	int	iWidth, iHeight;
	BOOL	bTopChanged = false;
	BOOL	bLeftChanged = false;

	if( !giCfgWindowSnap ) {
		return true;
	}

	if( !IsWindowVisible( hWnd ) ) {
		return true;
	}

	iWidth = LOWORD( lParam );
	iHeight = HIWORD( lParam );

	if( ghwnd != hWnd ) {
		GetWindowRect( hWnd, &rWnd );

		if( abs( rWnd.top - giCfgTop ) < giCfgWindowSnap ) {
			iTop = rWnd.top;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( abs( rWnd.bottom - giCfgTop ) < giCfgWindowSnap ) {
			iTop = rWnd.bottom;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( abs( rWnd.top - ( giCfgTop + iHeight ) ) < giCfgWindowSnap ) {
			iTop = rWnd.top - iHeight;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( abs( rWnd.bottom - ( giCfgTop + iHeight ) ) < giCfgWindowSnap ) {
			iTop = rWnd.bottom - iHeight;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( bTopChanged && bLeftChanged ) {
			giCfgTop = iTop;
			giCfgLeft = iLeft;
			return false;
		}
	}

	return true;
}

//
// Handle msgs for timer dlg
//
LRESULT CALLBACK wndproc_timer_dlg( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
	switch( msg ) {
	case WM_CLOSE:
		EndDialog( ghwndtimer, 0 );
		return false;

	case WM_COMMAND:
		switch( LOWORD( wparam ) ) {
		case ID_ENTER:
			MENUITEMINFO	miiM;
			char		a[256];

			if( !( gTimers = (struct Timer_t **) realloc( gTimers, ( giTimersCnt + 1 ) * sizeof( struct Timer_t * ) ) ) ) {
				MessageBox( NULL, "Couldn't allocate memory", "TimeIt error", MB_OK );
				EndDialog( ghwndtimer, 0 );
				return false;
			}
			if( !( gTimers[giTimersCnt] = (struct Timer_t *) malloc( sizeof( struct Timer_t ) ) ) ) {
				MessageBox( NULL, "Couldn't allocate memory", "TimeIt error", MB_OK );
				EndDialog( ghwndtimer, 0 );
				return false;
			}

			memset( gTimers[giTimersCnt], 0, sizeof( struct Timer_t ) );
			GetDlgItemText( ghwndtimer, ID_NAME, a, 256 );
			gTimers[giTimersCnt]->pszName = _strdup( a );
			GetDlgItemText( ghwndtimer, ID_MSG, a, 256 );
			gTimers[giTimersCnt]->pszMsg = _strdup( a );
			GetDlgItemText( ghwndtimer, ID_CMD, a, 256 );
			gTimers[giTimersCnt]->pszCmd = _strdup( a );
			gTimers[giTimersCnt]->iSecs = GetDlgItemInt( ghwndtimer, ID_H, NULL, 0 ) * 60 * 60 +
						      GetDlgItemInt( ghwndtimer, ID_M, NULL, 0 ) * 60 +
						      GetDlgItemInt( ghwndtimer, ID_S, NULL, 0 );
			gTimers[giTimersCnt]->fSave = Button_GetCheck( GetDlgItem( ghwndtimer, ID_SAVE ) );

			memset( &miiM, 0, sizeof( MENUITEMINFO ) );
			miiM.cbSize = sizeof( MENUITEMINFO );
			miiM.fMask = MIIM_ID | MIIM_STATE | MIIM_SUBMENU | MIIM_TYPE;
			miiM.fType = MFT_STRING;
			miiM.fState = MFS_ENABLED | MFS_UNCHECKED;
			miiM.wID = ID_TIMER_FIRST + giTimersCnt;
			miiM.hSubMenu = NULL;
			miiM.dwTypeData = _strdup( gTimers[giTimersCnt]->pszName );
			miiM.cch = 0;
			InsertMenuItem( ghsubmenu, giTimersCnt, true, &miiM );

			PostMessage( ghwnd, WM_COMMAND, ID_TIMER_FIRST + giTimersCnt, 0 );

			giTimersCnt++;

			WriteIniFile();

			EndDialog( ghwndtimer, 0 );
			return false;

		case IDCANCEL:
			EndDialog( ghwndtimer, 0 );
			return false;
		}
		return false;
	}

	return DefDlgProc( hwnd, msg, wparam, lparam );
}

// Show the dialog that lets you create new timers
int show_timer_dlg( void )
{
	if( !( ghwndtimer = CreateWindowEx( WS_EX_TOOLWINDOW | WS_EX_TOPMOST | WS_EX_CONTROLPARENT, "TimeIt_timer", "New timer",
			WS_OVERLAPPED | WS_BORDER | WS_SYSMENU,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			130, 
			204,
			NULL,
			NULL,
			ghinstance,
			NULL ) ) ) {
		MessageBox( NULL, "CreateWindow( timer_dlg ) failed!", "TimeIt", MB_OK );
		return 0;
	}

	if( !( CreateWindowEx( 0, "BUTTON", "", WS_CHILD | BS_DEFPUSHBUTTON,
			0, 0, 0, 0, 
			ghwndtimer,
			(HMENU) ID_ENTER,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( 0, "STATIC", "h", WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			2, 0, 40, 16, 
			ghwndtimer,
			(HMENU) ID_HTEXT,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( 0, "STATIC", "m", WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			42, 0, 40, 16, 
			ghwndtimer,
			(HMENU) ID_MTEXT,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( 0, "STATIC", "s", WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			82, 0, 40, 16, 
			ghwndtimer,
			(HMENU) ID_STEXT,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", "0", WS_VISIBLE | WS_CHILD | WS_TABSTOP,
			2, 16, 40, 20, 
			ghwndtimer,
			(HMENU) ID_H,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", "5", WS_VISIBLE | WS_CHILD | WS_TABSTOP,
			42, 16, 40, 20, 
			ghwndtimer,
			(HMENU) ID_M,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", "0", WS_VISIBLE | WS_CHILD | WS_TABSTOP,
			82, 16, 40, 20, 
			ghwndtimer,
			(HMENU) ID_S,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}

	if( !( CreateWindowEx( 0, "STATIC", "Name", WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			2, 40, 120, 16, 
			ghwndtimer,
			(HMENU) ID_NAMETEXT,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", "Noname", WS_VISIBLE | WS_CHILD | WS_TABSTOP | ES_AUTOHSCROLL,
			2, 56, 120, 20, 
			ghwndtimer,
			(HMENU) ID_NAME,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}

	if( !( CreateWindowEx( 0, "STATIC", "Msg", WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			2, 80, 120, 16, 
			ghwndtimer,
			(HMENU) ID_MSGTEXT,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", "Make magic!", WS_VISIBLE | WS_CHILD | WS_TABSTOP | ES_AUTOHSCROLL,
			2, 96, 120, 20, 
			ghwndtimer,
			(HMENU) ID_MSG,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( 0, "STATIC", "Command", WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			2, 120, 120, 16, 
			ghwndtimer,
			(HMENU) ID_MSGTEXT,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT", "", WS_VISIBLE | WS_CHILD | WS_TABSTOP | ES_AUTOHSCROLL,
			2, 136, 120, 20, 
			ghwndtimer,
			(HMENU) ID_CMD,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}
	if( !( CreateWindowEx( 0, "BUTTON", "Save timer", 
			WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_AUTOCHECKBOX,
			2, 160, 120, 20, 
			ghwndtimer,
			(HMENU) ID_SAVE,
			ghinstance, NULL ) ) ) {
		MessageBox( NULL, "CreateWindow() failed!", "TimeIt", MB_OK );
		return 0;
	}

	ShowWindow( ghwndtimer, SW_SHOW );
	UpdateWindow( ghwndtimer );

	SendMessage( ghwndtimer, DM_SETDEFID, (WPARAM) ID_ENTER, 0 );

	return 1;
}
